package coral.solvers.rand;

import java.util.Arrays;
import java.util.Set;

import symlib.SymLiteral;

import coral.util.Config;
import coral.util.Range;
import coral.util.callers.IntervalSolverCaller;
import coral.util.callers.RealPaverCaller;


public class Util {
	  
  public static int[] extractVarIds(Set<SymLiteral> vars) {
    int[] ids = new int[vars.size()];
    int i = 0;
    
    for(SymLiteral lit : vars) {
      ids[i] = lit.getId();
      i++;
    }
    
    return ids;
  }
  
  public static IntervalSolverCaller getIntervalSolver(String solverName) {
    if(solverName.equals("realpaver")) {
      return new RealPaverCaller();
    } else if(solverName.equals("icos")) {
//      return new ICOSCaller();
      throw new RuntimeException("ICOS is useless: " + solverName);
    } else {
      throw new RuntimeException("Unknown interval solver: " + solverName);
    }
  }
 
}
