package symlib;

import coral.util.visitors.interfaces.StringVisitor;
import coral.util.visitors.interfaces.TypedVisitor;
import coral.util.visitors.interfaces.VoidVisitor;

public class SymAsDouble extends SymCast implements SymDouble {
  
  public SymAsDouble(SymNumber arg) {
    super(arg);
  }

  @Override
  public String accept(StringVisitor visitor) {
    return "ASDOUBLE(" + visitor.visitSymNumber(super.getArg()) + ")";
  }

  @Override
  public SymNumber accept(TypedVisitor visitor) {
    return new SymAsDouble((SymNumber)visitor.visitSymNumber(super.getArg()));
  }

  @Override
  public double eval() {
    return this.evalNumber().doubleValue();
  }

  @Override
  public SymNumber clone() {
    return new SymAsDouble(super.getArg().clone());
  }
  
  public String toString() {
    return "ASDOUBLE(" + super.getArg() + ")"; 
  }
}
